function filename=create_funcs(f_str,df_str,varargin)
% f_str='z*z*z-1.0'
% df_str='3.*z*z'
  p = inputParser;
  p.addParamValue('file', 'funcs.h', @ischar );
  p.addParamValue('verbose', 1, @(x) ismember(x,0:1) );
  p.parse(varargin{:});
  R=p.Results;
  
  S=Thrust.tools.getCurrentFunctionPath();
  filename=[S,R.file];
  [fid,mess]=fopen(filename,'w');
  if fid<0
    disp(mess)
    error('Unable to open file %s\n',filename)
  end
  fprintf(fid,'#include <thrust/complex.h>\n\n');
  fprintf(fid,'thrust::complex<double> I=thrust::complex<double>(0.,1.);\n\n');

  fprintf(fid,'__device__ thrust::complex<double> f(thrust::complex<double> z){\n');
  fprintf(fid,'  return  %s;\n',f_str);
  fprintf(fid,'}\n');
  fprintf(fid,'__device__ thrust::complex<double> df(thrust::complex<double> z){\n');
  fprintf(fid,'  return  %s;\n',df_str);
  fprintf(fid,'}\n');
  fclose(fid);
  if R.verbose>0, fprintf('creating file %s\n',filename);end