function varargout=creator(varargin)
  p = inputParser; 
  p.addParamValue('verbose', 0, @(x) isscalar(x) & isnumeric(x));
  p.parse(varargin{:});
  T=Thrust.types();
  C=Thrust.containers();
  fail=0;
  for type=T
    for container=C
%      whos
%        fprintf('%s %s',type{1},container{1});
      fail=fail+test1(container{1},type{1},false,p.Results.verbose);
    end
  end
  if nargout==1, varargout{1}=fail;end
end

function failure=test1(container,type,iscomplex,verbose)
  failure=0;
  dim=randi(10^5);
  cmd=sprintf('x=mThrust(%d,''%s'',''%s'',%s);',dim,container,type,Thrust.tools.logical2str(iscomplex));
  if verbose>0,fprintf('%s \n',cmd);end
  try 
    eval(cmd);
  catch ME
    causeException = MException('MATLAB:mThrust:','toto');
    ME = addCause(ME,causeException);
    failure=1;
    rethrow(ME)
  end
  if (verbose>0)
    if (failure==0), fprintf('  -> OK\n');else fprintf('  -> Failed\n');end
  end
end