function varargout=init(varargin)
P = mfilename('fullpath');
I=strfind(P,filesep);
P=P(1:I(end-1));
p = inputParser; 
p.addParamValue('debug', false, @islogical );
p.addParamValue('dir', false, @islogical );
p.addParamValue('verbose', true, @islogical );
p.parse(varargin{:});

if p.Results.dir
  varargout{1}=P;
  return
end
debug=p.Results.debug;
addpath(P)
%addpath([P,'common'])

P=Thrust.tools.getConfigPaths();
if debug
  if exist(P.MEXDEBUG_DIR,'dir')
    addpath(P.MEXDEBUG_DIR)
  else
    fprintf('Run for example :\n  Thrust.compile.build(''cudapath'',''%s'',''debug'',true)\n',Thrust.tools.getCUDApath())
    error('Unable to load directory %s\n',P.MEXDEBUG_DIR)
  end
else
  if exist(P.MEX_DIR,'dir')
    addpath(P.MEX_DIR)
  else
    fprintf('Run for exemple:\n  Thrust.compile.build(''cudapath'',''%s'')\n',Thrust.tools.getCUDApath())
    error('Unable to load directory %s\n',P.MEX_DIR)
  end
end

if p.Results.verbose
  fprintf('mThrust toolbox configuration ')
  if debug, fprintf('(debug mode)');end
  fprintf('\n  CUDA version : %s\n',Thrust.tools.getCUDAversion());
  fprintf('  CUDA sms     : %s\n',Thrust.tools.getCUDAsms());
  fprintf('  CUDA path    : %s\n',Thrust.tools.getCUDApath());
end