function obj=sequence(dim,varargin)
% SEQUENCE sequence fills the range [first, last) with a sequence of numbers. 
%   The first value of the sequence of numbers is given by option 'init' (default 0)
%   The difference between consecutive elements is given by option 'step' (default 1)
  p = inputParser; 
  p.addParamValue('init', 0, @(x) isscalar(x) & isnumeric(x));
  p.addParamValue('step', 1, @(x) isscalar(x) & isnumeric(x));
  p.addParamValue('container', 'device', @(x) ismember(x,Thrust.getContainers()));
  p.addParamValue('type', 'double', @(x) ismember(x,Thrust.types('type','numerical')));
  p.parse(varargin{:});
  init=p.Results.init;step=p.Results.step;
  container=p.Results.container;
  type=p.Results.type;
  obj=mThrust(dim,container,type);
  mex_mThrust_sequence(obj,Thrust.toCtype(0,'int'),Thrust.toCtype(dim,'int'), ...
                       Thrust.toCtype(init,obj.type),Thrust.toCtype(step,obj.type));
end