function sequence(obj,first,last,varargin)
% SEQUENCE fills the range [first, last) with a sequence of numbers. 
%   Inline transformation.
%   The first value of the sequence of numbers is given by option 'init' (default 0)
%   The difference between consecutive elements is given by option 'step' (default 1)
  assert( Thrust.ismThrust(obj) , '1st parameter must be a mThrust object')
  assert( ~obj.complex && isnumerical(obj), '1rst parameter not to be complex or logical')
  assert( first>=1 & first<last & last<=obj.dim,'2nd and/or 3rd parameter failed conditions')
  p = inputParser; 
  p.addParamValue('init', 0, @(x) isscalar(x) & isnumeric(x));
  p.addParamValue('step', 1, @(x) isscalar(x) & isnumeric(x));
  p.parse(varargin{:});
  init=p.Results.init;step=p.Results.step;
  
  mex_mThrust_sequence(obj,Thrust.toCtype(first-1,'int'),Thrust.toCtype(last,'int'), ...
                       Thrust.toCtype(init,obj.type),Thrust.toCtype(step,obj.type));
end