/* Generic for math operator <, <=, > and >= 
   Don't works with complex 
 */

template  <typename T>
void mx_mThrust_opVec_type( const mxArray *prhs[] ){
  char *container[] = {
    mxArrayToString(mxGetProperty(prhs[0],0,"container")),
    mxArrayToString(mxGetProperty(prhs[1],0,"container")),
    mxArrayToString(mxGetProperty(prhs[2],0,"container"))
  };
  assert( (strcmp(container[0],container[1])==0) );
  
  if (strcmp(container[0], "host")==0){
    mx_mThrust_opVec<T ,thrust::host_vector<T>, thrust::host_vector<logical> >(prhs);
  }else if (strcmp(container[0], "device")==0){
    mx_mThrust_opVec<T ,thrust::device_vector<T>, thrust::device_vector<logical> >(prhs);
  }else{
    mxFree(container[0]);mxFree(container[1]);mxFree(container[2]);
    mexErrMsgIdAndTxt("MESS","Unknow container."); 
  }
  mxFree(container[0]);mxFree(container[1]);mxFree(container[2]);
}

template  <typename T>
void mx_mThrust_opCst_type( const mxArray *prhs[] ){
  char *container[] = {
    mxArrayToString(mxGetProperty(prhs[0],0,"container")),
    mxArrayToString(mxGetProperty(prhs[2],0,"container"))
  };
  
  if (strcmp(container[0], "host")==0){
      mx_mThrust_opCst<T ,thrust::host_vector<T>, thrust::host_vector<logical> >(prhs);
  }else if (strcmp(container[0], "device")==0){
      mx_mThrust_opCst<T ,thrust::device_vector<T>, thrust::device_vector<logical> >(prhs);
  }else{
    mxFree(container[0]);mxFree(container[1]);
    mexErrMsgIdAndTxt("mThrustToolbox:eq","Unknow container."); 
  }
  mxFree(container[0]);mxFree(container[1]);
}

void mexFunction( int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[] )     
{
  MEXPRINTF("starting");
  if (nlhs !=0 || nrhs != 3) 
    mexErrMsgTxt("Bad input.");
  assert( mxIsClass(prhs[0],"mThrust") && mxIsClass(prhs[2],"mThrust") );
  logical isScalar=false;
  logical ismThrust=mxIsClass(prhs[1],"mThrust");
  if (!ismThrust) isScalar=mxIsScalar(prhs[1]);
  assert( ismThrust || isScalar ); 
  logical *iscomp=(logical *)mxGetPr(mxGetProperty(prhs[0],0,"complex"));
  if (*iscomp)
    mexErrMsgIdAndTxt(MESS,"Operator not allowed with complex"); 
  if (ismThrust){
    iscomp=(logical *)mxGetPr(mxGetProperty(prhs[1],0,"complex"));
    if (*iscomp)
      mexErrMsgIdAndTxt(MESS,"Operator not allowed with complex"); 
  }else if (mxIsComplex(prhs[1]))
      mexErrMsgIdAndTxt(MESS,"Operator not allowed with complex");
  
    
  char *type =mxArrayToString(mxGetProperty(prhs[0],0,"type"));
  if (strcmp(type, "double")==0){
    if (isScalar) mx_mThrust_opCst_type<double>(prhs);else mx_mThrust_opVec_type<double>(prhs);
  }else if (strcmp(type, "int")==0){
    if (isScalar) mx_mThrust_opCst_type<int>(prhs);else mx_mThrust_opVec_type<int>(prhs);
  }else if (strcmp(type, "float")==0){
    if (isScalar) mx_mThrust_opCst_type<float>(prhs);else mx_mThrust_opVec_type<float>(prhs);
  }else if (strcmp(type, "unsigned")==0){
    if (isScalar) mx_mThrust_opCst_type<unsigned>(prhs);else mx_mThrust_opVec_type<unsigned>(prhs);
  }else{
    mxFree(type);
    mexErrMsgIdAndTxt(MESS,"type not implemented.");
  }
  mxFree(type);
  MEXPRINTF("ending");
}