#pragma once
#include <thrust/complex.h>

template <typename T>
struct real_functor : public thrust::unary_function< T , thrust::complex<T> >
{
  __host__ __device__
  T operator()( thrust::complex<T> z) const
  {
    return z.real();
  }
};

template <typename T>
struct imag_functor : public thrust::unary_function< T , thrust::complex<T> >
{
  __host__ __device__
  T operator()( thrust::complex<T> z) const
  {
    return z.imag();
  }
};