#include <string>
#include "textcolors.h"
#include "ObjectHandle.h"
#include "mThrust.h"
#include "mex.h"

struct thrust::logical_not<logical> logical_functor;


template <typename T,typename VectorBool> 
void mx_mThrust_op(const mxArray *prhs[]){
  
  VectorBool &gx = get_object< VectorBool >(mxGetProperty(prhs[0],0,"handle"));
  thrust::transform(gx.begin(),gx.end(), gx.begin(), logical_functor);
}
// see functional.h :
// thrust::logical_and, thrust::logical_or, thrust::logical_not



// prhs[0] : input/output mThrust object
void mexFunction( int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[] )     
{
  MEXPRINTF("starting");
  if (nlhs !=0 || nrhs != 1) 
    mexErrMsgTxt("Bad input.");
  assert(mxIsClass(prhs[0],"mThrust"));
  char *container =mxArrayToString(mxGetProperty(prhs[0],0,"container"));
  
  assert( strcmp( mxArrayToString(mxGetProperty(prhs[0],0,"type")), "logical" ) == 0);
  
  if (strcmp(container, "host")==0){
    mx_mThrust_op<logical,thrust::host_vector<logical> >(prhs);
  }else if (strcmp(container, "device")==0){
    mx_mThrust_op<logical,thrust::device_vector<logical> >(prhs);
  }else{
    mxFree(container);
    mexErrMsgIdAndTxt("mThrustToolbox:inline_not","container not implemented.");
    return;
  }
  mxFree(container);
}