/*
*/

#include <string>
#include "textcolors.h"
#include "ObjectHandle.h"
#include "mThrust.h"
#include "mex.h"

#define MESS "mThrustToolbox:uminus"

// template <typename T,typename Vector,typename VectorOut> 
// void mx_mThrust_op_complex(const mxArray *prhs[]){
//   typedef typename Vector::value_type Tin;
//   typedef typename VectorOut::value_type Tout;
//   Vector &gx = get_object< Vector >(mxGetProperty(prhs[0],0,"handle"));
//   VectorOut &gz = get_object<VectorOut>(mxGetProperty(prhs[2],0,"handle"));
//   assert((gx.size()==gz.size()));
//   T *pa_r = (T *)mxGetPr(prhs[1]);
//   T *pa_i = (T *)mxGetPi(prhs[1]);
//   thrust::complex<T> a(*pa_r,*pa_i);
//   thrust::transform(gx.begin(),gx.end(),gz.begin(), op_functor<Tin,thrust::complex<T>,Tout>(a));
// }
// 
// template <typename T,typename Vector,typename VectorOut> 
// void mx_mThrust_op_real(const mxArray *prhs[]){
//   typedef typename Vector::value_type Tin;
//   typedef typename VectorOut::value_type Tout;
//   Vector &gx = get_object< Vector >(mxGetProperty(prhs[0],0,"handle"));
//   VectorOut &gz = get_object<VectorOut>(mxGetProperty(prhs[1],0,"handle"));
//   assert((gx.size()==gz.size()));
//   thrust::transform(gx.begin(),gx.end(),gz.begin(),  thrust::negate<T>());
// }

template <typename Vector> 
void mx_mThrust_op(const mxArray *prhs[]){
  typedef typename Vector::value_type T;
  Vector &gx = get_object< Vector >(mxGetProperty(prhs[0],0,"handle"));
  Vector &gz = get_object< Vector >(mxGetProperty(prhs[1],0,"handle"));
  assert((gx.size()==gz.size()));
  thrust::transform(gx.begin(),gx.end(),gz.begin(),  thrust::negate<T>());
}

template  <typename T>
void mx_mThrust_opcst_type(const mxArray *prhs[] ){
  char *container[] = {
    mxArrayToString(mxGetProperty(prhs[0],0,"container")),
    mxArrayToString(mxGetProperty(prhs[1],0,"container"))
  };
  assert( (strcmp(container[0],container[1])==0) );
  bool iscomplex[2]; 
  logical *iscomp=(logical *)mxGetPr(mxGetProperty(prhs[0],0,"complex"));
  iscomplex[0]=*iscomp;
  iscomp=(logical *)mxGetPr(mxGetProperty(prhs[1],0,"complex"));
  iscomplex[1]=*iscomp;
  assert( iscomplex[0]==iscomplex[1] );
  if (strcmp(container[0], "host")==0){
    typedef thrust::host_vector<thrust::complex<T> > VecCplx;
    typedef thrust::host_vector<T> VecReal;
    if (iscomplex[0])
      mx_mThrust_op<VecCplx>(prhs);
    else 
      mx_mThrust_op<VecReal>(prhs);
  }else if (strcmp(container[0], "device")==0){
    typedef thrust::device_vector<thrust::complex<T> > VecCplx;
    typedef thrust::device_vector<T> VecReal;
    if (iscomplex[0])
      mx_mThrust_op<VecCplx>(prhs);
    else 
      mx_mThrust_op<VecReal>(prhs);
  }else
    mexWarnMsgIdAndTxt(MESS,"Unknow container.");
  mxFree(container[0]);mxFree(container[1]);
}

// unary arithmetic operator <OP> : +,-
// prhs[0] : input mThrust vector {Vin}
// prhs[2] : output mThrust vector {vout} <- <OP> {Vin}
void mexFunction( int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[] )     
{
  MEXPRINTF("starting");
  if (nlhs !=0 || nrhs != 2) 
    mexErrMsgTxt("Bad input.");
  
  assert(mxIsClass(prhs[0],"mThrust") && mxIsClass(prhs[1],"mThrust"));
  
  char *type[] = {
    mxArrayToString(mxGetProperty(prhs[0],0,"type")),
    mxArrayToString(mxGetProperty(prhs[1],0,"type"))
  };
  assert( strcmp(type[0],type[1])==0 );
  if (strcmp(type[0], "int")==0){
    mx_mThrust_opcst_type<int>(prhs);
  }else if (strcmp(type[0], "unsigned")==0){
    mx_mThrust_opcst_type<unsigned>(prhs);
  }else if (strcmp(type[0], "float")==0){
    mx_mThrust_opcst_type<float>(prhs);
  }else if (strcmp(type[0], "double")==0){
    mx_mThrust_opcst_type<double>(prhs);
  }else
    mexWarnMsgIdAndTxt("mThrustToolbox:uplus","type not implemented.");
  mxFree(type[0]);mxFree(type[1]);
  MEXPRINTF("ending");
}